#インポート処理
require 'common'

module ActiveRecord
  class Base
    module PettanImporter
      def self.included(base)
        base.extend(ClassMethods)
        base.__send__ :include, InstanceMethods
      end
      
      module ClassMethods
        def each_import data
          data.each do |n, d|
            yield n, d
          end
        end
        
        def replace_system_picture attr
          d = attr["system_picture"]
          return nil if d.blank?
          imager = PettanImager.load(Base64.decode64(d.to_s))
          return nil unless imager
          sp = SystemPicture.store(imager)
          return false unless sp
          attr["system_picture_id"] = sp.id
          attr.delete "system_picture"
          true
        end
        
        def modify_object(name, attr, key = 'name')
          c = 'find_by_' + key.to_s
          r = self.__send__ c, name
          if r
            r.attributes = attr
          else
            r = self.new attr
            r[key] = name
          end
          r
        end
        
        def import_text(data, &blk)
          d = JSON.parse_no_except(data)
          return false unless d
          res = []
          self.transaction do
            d.each do |name, item|
              m = blk.call(name, item)
              res.push(m) unless m.valid?
            end
            raise ActiveRecord::Rollback unless res.empty?
          end
          res
        end
        
        def import_file(filename, &blk)
          t = nil
          begin
            t = File.open(filename, 'r').read
          rescue
            return false
          end
          self.import_text t, &blk
        end
        
      end
      
      module InstanceMethods
        private
        
        public
        
      end
      
    end
    include PettanImporter
  end
end

